local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_Bags"

local defaults = {
}
local options = {
}
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local ldbicon = LibStub("LibDBIcon-1.0")
local L = LibStub("AceLocale-3.0"):GetLocale(childName, true)
local db,modDB

local bagTypes = {
	[0] = L['Unspecified'],
	[1] = L['Quiver'],
	[2] = L['Ammo Pouch'],
	[4] = L['Soul Bag'],
	[8] = L['Leatherworking Bag'],
	[16] = L['Inscription Bag'],
	[32] = L['Herb Bag'],
	[64] = L['Enchanting Bag'],
	[128] =	L['Engineering Bag'],
	[256] = L['Keyring'],
	[512] = L['Gem Bag'],
	[1024] = L['Mining Bag'],
	[2048] = L['Unknown'],
	[4096] = L['Vanity Pets'],
}
local refillframe
local frames = {}
local x,y,n,m,b,c
local free, full
local bagID,bagType
local NUM_BAG_SLOTS = NUM_BAG_SLOTS
local NUM_BANKBAGSLOTS = NUM_BANKBAGSLOTS
local BANK_CONTAINER = BANK_CONTAINER
local currentFrame
local function OnText(message)
	addon['OnText'](childName, message)
end

local function buildFrame(func)
	frames[#frames + 1] = func()
	if(not currentFrame) then
		currentFrame = #frames
	end
end

local function OnDataUpdate()
	bagID = 0
	n,m = 0,0
	free,full = {},{}
	while(bagID<=NUM_BAG_SLOTS) do
		b = GetContainerNumSlots(bagID)
		c = GetContainerNumFreeSlots(bagID)
		bagType = GetItemFamily(GetBagName(bagID))
		if(not bagType or bagType==0) then
			bagType = 0
			full[0] = full[0] or 0
			free[0] = free[0] or 0
			free[0] = free[0] + c
			full[0] = full[0] + b
		else
			full[bagType] = full[bagType] or 0
			free[bagType] = free[bagType] or 0
			free[bagType] = free[bagType] + c
			full[bagType] = full[bagType] + b
		end
		-- print(bagTypes[bagType],bagType,addon['db']['profile']['bagTypes'][bagTypes[bagType]])
		if(db['bagTypes'][bagTypes[bagType]]==true) then
			n = n + c
			m = m + b
		end
		bagID = bagID + 1
	end
	if(not db['showFree']) then
		n = m - n
	end
	OnText(format("%d/%d",n,m))
end
local function addRefill()
  local typ,id,link = GetCursorInfo()
  if(link and typ ~= 'merchant') then
    if(typ=="item") then
      local i = addon['itemInfo'](id)
      if(not modDB[i['itemName']]) then
        modDB[i['itemName']] = { ['itemStackCount'] = i['itemStackCount'],['itemId'] = i['itemId'],['itemRefill'] = i['itemStackCount']}
      end
    end
    ClearCursor()
		print(typ,id,link)
  end
end

local function buildRefillFrame()
	local frame = CreateFrame("Frame","$PARENTRefillFrame",refillframe)
	frame:SetWidth(frame:GetParent():GetWidth() - 60)
	frame:SetHeight(frame:GetParent():GetHeight() - 90)
	local but = CreateFrame("Button","$PARENTDropIcon",frame,"ActionButtonTemplate")
	frame:SetPoint("TOPLEFT",refillframe,"TOPLEFT",32,-80)
	but:SetPoint("TOPLEFT",frame,"TOPLEFT",0,0)
	but:SetScript("OnReceiveDrag",addRefill)
	but:SetScript("OnClick",addRefill)
end

local function getPref2(info)
-- print("get",info[#info])
	return db['bagTypes'][info[#info]]
end

local function setPref2(info,value)
-- print("set",info[#info],value)
	db['bagTypes'][info[#info]] = value
	OnDataUpdate()
end

local function getPref(info)
-- print("get",info[#info])
	return db[info[#info]]
end

local function setPref(info,value)
-- print("set",info[#info],value)
	db[info[#info]] = value
	OnDataUpdate()
end
local function OnTooltip()
	GameTooltip:AddLine(childName)
	x=0
	y=0
	while(x<8000) do
		if(full[x]) then
			if(full[x] > 0) then
				n = free[x]
				if(not db['showFree']) then
					n = full[x] - n
				end
				GameTooltip:AddDoubleLine(bagTypes[x],n.."/"..full[x])
			end
		end
		x = 2^y
		y = y + 1
	end
end
local function init()
	options = addon['InitConfig'](addon, childName, true, {
		['name'] = childName,
		['type'] = "data source",
		['OnTooltipShow'] = OnTooltip,
	}, getPref, setPref)
	db = addon['db']['profile'][childName]
	db['Refills'] = db['Refills'] or {}
	modDB = db['Refills']
--	refillframe = addon['createSpecialFrame']("BagsRefill",db)
--	buildFrame(buildRefillFrame)
	addon['AddConfigMenu'](addon, {
		['name'] = L['Bagtypes'],
		['order'] = 2,
		['childGroups'] = 'tab',
		['menuGet'] = getPref2,
		['menuSet'] = setPref2
	}, options)
	db['bagTypes'] = db['bagTypes'] or {
		[bagTypes[0]] = true,
	}
	addon['AddConfigEntry'](addon, childName, "toggle","showFree",L['Show free space'],L['Show free space instead of used space'],1,nil,nil,nil,nil,options['args'][childName])
	for k,v in pairs(bagTypes) do
		addon['AddConfigEntry'](addon, childName, "toggle",v,v,nil,1,nil,nil,nil,nil,options['args'][L['Bagtypes']])
	end
	addon['RegisterEventThrottle'](childName,"BAG_UPDATE", 1, OnDataUpdate)
	OnDataUpdate()
end

addon['startup'](addon, name, childName, init, true, defaults)